#!/bin/sh
#
# Shell	script to install Java-based GUI RAID Manager.


InputInstallPath(){
	if [ -r	/usr/.ift.ini ]; then
		echo " "
		echo "Please Remove the Previous Installed Package First!"
		return 1
	fi

	more <<	"EOF"

=====================================================================
Please Select Install Path
=====================================================================

EOF

	finish=
	while [	x$finish = x ];	do
		echo "Install to \"$INSTALLDIR\" ok?(y/n)"
		read reply
		case $reply	in 
			y |	yes)
				if [ -r	"$INSTALLDIR" ]; then
					finish_1=
					while [	x$finish_1 = x ]; do
						echo " "					
						echo "Specified Directory Already Exist. Continue?(y/n)"
						read reply_1
						case $reply_1 in
							y |	yes	)
								if [ -r "${INSTALLDIR}/GuiRM" ]; then
									echo "There Are Conflict Directories In Current Install Directory."
									echo "Please Input Another Directory As Install Directory:"
									read INSTALLDIR
									finish_1=1
								else
									INSTALLDIR=${INSTALLDIR}/GuiRM
									mkdir -p $INSTALLDIR/bin
									mkdir -p $INSTALLDIR/cfg
									mkdir -p $INSTALLDIR/log
									echo "[PRIMARY]" > $INSTALLDIR/cfg/agent.ini
									finish_1=1
									finish=1
								fi;;
							n |	no )
								echo "Please Input Install Directory:"
								read INSTALLDIR
								finish_1=1;;
						esac
					done
				else			
					INSTALLDIR=${INSTALLDIR}/GuiRM
					mkdir -p $INSTALLDIR/bin
					mkdir -p $INSTALLDIR/cfg
					mkdir -p $INSTALLDIR/log
					echo "[PRIMARY]" > $INSTALLDIR/cfg/agent.ini
					finish=1
				fi;;
			n |	no)
				echo "Please Input Install Directory in Absolute Path:"
				read INSTALLDIR;;
		esac
	done 

}

InputPrimaryAgentProperty(){
	more <<	"EOF"

=====================================================================
		Primary Agent Installation
=====================================================================
EOF

	#set [PRIMARY] IPADDR
	finish=
	while [	x$finish = x ];	do
		echo " "
		echo "Please Input this Host's IP Address:"
		read PRIMARYIP
		echo "IP address = \"$PRIMARYIP\" ok? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "IPADDR=$PRIMARYIP" >>	$INSTALLDIR/cfg/agent.ini
				finish=1;;
			n |	no )
				;;
		esac
	done

	#set [PRIMARY] PORT
	finish=
	while [	x$finish = x ];	do
		echo " "
		echo "Primary Agent Port = \"$PRIMARYPORT\", ok? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "PORT=$PRIMARYPORT" >>	$INSTALLDIR/cfg/agent.ini
				finish=1;;
			n |	no )
				echo "Please Input Primary Agent Port:"
				read PRIMARYPORT;;
		esac
	done

	InputRedundentProperty

	InputManagedSecondaryAgentProperty

}

InputRedundentProperty() {
	finish=
	while [	x$finish = x ];	do
		echo " "
		echo "Have Redundent Agent? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				#[PRIMARY] PEER_PRIMARY
				finish_1=
				while [	x$finish_1 = x ]; do
					echo " "
					echo "Please Input Peer Primary Agent's IP Address:"
					read PEER_PRIMARY
					echo "Set Peer Primary Agent's IP Address = ${PEER_PRIMARY}, ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							;;
					esac
				done
				
				#[PRIMARY] PEER_PRIMARY_PORT	
				finish_1=
				while [	x$finish_1 = x ]; do
				echo " "
				echo "Set Peer Primary Agent's Port at \"$PEER_PRIMARY_PORT\" ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							echo "Please Input Peer Primary Agent's Port:"
							read PEER_PRIMARY_PORT;;
					esac
				done
		
				#[PRIMARY] PREFERRED_MODE
				finish_1=
				while [	x$finish_1 = x ]; do
					echo " "
					echo "Set Local Primary Agent Mode to \"$PREFERRED_MODE\" ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							echo "Please Input Local Primary Agent Mode? (0:Standby, 1:Active)"
							read PREFERRED_MODE
							case $PREFERRED_MODE in
								0 )
									PREFERRED_MODE="STANDBY";;
								1 )
									PREFERRED_MODE="ACTIVE";;
								* )
									echo "Undefined Mode! Please Choose \"0\" or \"1\"";;
							esac;;	 
					esac
				done
				
				#[PRIMARY] NEGOTIATION_TIME
				finish_1=
				while [	x$finish_1 = x ]; do
					echo " "
					echo "Set Negotiation Time = $NEGOTIATION_TIME sec ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							echo "PEER_PRIMARY=$PEER_PRIMARY,$PEER_PRIMARY_PORT" >>	$INSTALLDIR/cfg/agent.ini
							echo "PREFERRED_MODE=$PREFERRED_MODE" >> $INSTALLDIR/cfg/agent.ini
							echo "NEGOTIATION_TIME=$NEGOTIATION_TIME" >> $INSTALLDIR/cfg/agent.ini
							finish_1=1;;
						n |	no )
							echo "Please Input Negotiation Time (second):"
							read NEGOTIATION_TIME;;
				esac
				
				finish=1
				done;;
			n |	no )
				finish=1;;
		esac
	done
			
}

InputManagedSecondaryAgentProperty() {
	index=1
	finish=
	SECONDARYIP=$PRIMARYIP
	while [	x$finish = x ];	do
		echo " "
		echo "Add Managed Secondary Agent IP=\"$SECONDARYIP\" Port=\"$SECONDARYPORT\"? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "HOST${index}=$SECONDARYIP,$SECONDARYPORT"	>> $INSTALLDIR/cfg/agent.ini
				echo ">> Secondary Agent IP=\"$SECONDARYIP\", Port=\"$SECONDARYPORT\" Added."
				SECONDARYPORT=58633
				index=`expr	$index + 1`
				finish_1=
				while [	x$finish_1 = x ]; do
					echo " "
					echo "Add More Managed Secondary Agent? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							InputSecondaryIPPort;
							finish_1=1;;
						n |	no )
							finish_1=1
							finish=1;;
					esac
				done;;
			n |	no )
				InputSecondaryIPPort;;
		esac
	done
		

}

InputSecondaryIPPort() {
	finish_isi=
	while [	x$finish_isi = x ];	do
		echo " "
		echo "Please Input Managed Secondary Agent's IP Address:"
		read SECONDARYIP
		echo "Set Managed Secondary Agent's IP = \"$SECONDARYIP\"? ok (y/n)"
		read agreement_isi
		case $agreement_isi in
			y |	yes	)
				finish_isi=1;;
			n |	no )
				;;
		esac
	done
	
	finish_isi=
	while [	x$finish_isi = x ];	do
		echo " "
		echo "Set Managed Secondary Agent's Port at \"$SECONDARYPORT\"? ok (y/n)"
		read agreement_isi
		case $agreement_isi	in
			y |	yes	)
				finish_isi=1;;
			n |	no )
				echo "Please Input Managed Secondary Agent's Port:"
				read SECONDARYPORT;;
		esac
	done
		
}

InputSecondaryAgentProperty() {
	more <<	"EOF"

=====================================================================
		Secondary Agent Installation 
=====================================================================

EOF
	echo "[SECONDARY]" >> $INSTALLDIR/cfg/agent.ini
	finish=
	while [	x$finish = x ];	do
		echo "Set Local Secondary Agent Port at \"$SECONDARYPORT\" ok? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "PORT=$SECONDARYPORT" >> $INSTALLDIR/cfg/agent.ini
				finish=1;;
			n |	no )
				echo "Please Input Secondary Agent's Port:"
				read SECONDARYPORT;;
		esac
	done

	echo " "
	finish=
	while [	x$finish = x ];	do
		echo "Set Event Polling Time = $EVENT_POLL_TIME sec ok? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "EVENT_POLL_TIME=$EVENT_POLL_TIME"	>> $INSTALLDIR/cfg/agent.ini
				finish=1;;
			n |	no )
				echo "Please Input Event Polling Time (sec):"
				read EVENT_POLL_TIME;;
		esac
	done
		
}

InputNPCProperty() {
	more <<	"EOF"

=====================================================================
		NPC Installation
=====================================================================
EOF

	InputNPCEmail
	InputNPCBroadcast
	InputNPCPager
	InputNPCFax
	InputNPCSnmptrap
}

InputNPCEmail()	{
	echo "[EMAIL]" >> $INSTALLDIR/cfg/agent.ini
	finishAll=
	while [	x$finishAll = x ];	do
		echo " "
		echo "Would You Like to Config Email Function? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish=
				while [	x$finish = x ];	do
					echo " "
					echo "Please Input Sender's Email Address:"
					read MYEMAIL
					echo "Set Sender's Email Address = $MYEMAIL ok? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							echo "MYEMAIL=$MYEMAIL"	>> $INSTALLDIR/cfg/agent.ini
							finish=1;;
						n |	no )
							;;
					esac
				done

				finish=
				while [	x$finish = x ];	do
					echo " "
					echo "Please Input SMTP SERVER's IP:"
					read SMTPSERVER
					echo "Set SMTP SERVER IP to $SMTPSERVER ok? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							echo "SMTPSERVER=$SMTPSERVER" >> $INSTALLDIR/cfg/agent.ini
							finish=1;;
						n |	no )
							;;
					esac
				done
	
				finish=
				MORE=
				while [	x$finish = x ];	do
					echo " "
					echo "Would You Like to Input ${MORE}Recever's Email Information? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							finish_1=
							while [	x$finish_1 = x ]; do
								echo "Please Input Recever's Email Address:"
								read EMAILADDR
								echo "Add Recever \"$EMAILADDR\" ok? (y/n)"
								read agreement_1
								case $agreement_1 in
									y |	yes	)
										MORE='More '
										finish_1=1;;
									n |	no )
										;;
								esac
							done 

							finish_1=
							while [	x$finish_1 = x ]; do
								echo "Set Subject to \"$EMAILSUB\" ok? (y/n)"
								read agreement_1
								case $agreement_1 in
									y |	yes	)
										finish_1=1;;
									n |	no )
										echo " "
										echo "Please Input Subject of The Email to \"$EMAILADDR\":"
										read EMAILSUB;;
								esac
							done 

							EMAIL_COUNT=`expr $EMAIL_COUNT + 1`
							echo "ADDR${EMAIL_COUNT}=${EMAILADDR},${EMAILSUB},${EMAILCONTENT}" >> $INSTALLDIR/cfg/agent.ini;;
						n |	no )
							finish=1;;
					esac
				done

				echo "COUNT=$EMAIL_COUNT" >> $INSTALLDIR/cfg/agent.ini
				finishAll=1;;

			n |	no )
				finishAll=1;;
		esac	
	done
	
}

InputNPCBroadcast()	{
	echo "[BROADCAST]" >> $INSTALLDIR/cfg/agent.ini
	MORE=
	finish=
	while [	x$finish = x ];	do
		echo " "
		echo "Would You Like to Input ${MORE}Host IP Address for Broadcasting? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				echo "Please Input Host IP Address for Broadcasting:"
				read BROADADDR
				echo "Add Host IP Address \"$BROADADDR\" for Broadcasting ok? (y/n)"
				read agreement
				case $agreement	in
					y |	yes	)
						MORE='More '
						BROADCAST_COUNT=`expr $BROADCAST_COUNT + 1`
						echo "ADDR${BROADCAST_COUNT}=${BROADADDR},119" >> $INSTALLDIR/cfg/agent.ini;;
					n |	no )
						;;
				esac;;
			n |	no )
				finish=1;;
		esac
	done

	echo "COUNT=$BROADCAST_COUNT" >> $INSTALLDIR/cfg/agent.ini

}

InputNPCPager()	{
	echo "[PAGER]" >> $INSTALLDIR/cfg/agent.ini
	MORE=
	finish=
	while [	x$finish = x ];	do
		echo " "
		echo "Would You Like to Add ${MORE}Modem Interfaces For Pager? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Modem COM Port:(1-9)"
					read PAGER_COM
					case $PAGER_COM	in
						1 |	2 |	3 |	4 |	5 |	6 |	7 |	8 |	9 )
							finish_1=1;;
						* )
							;;
					esac
				done
		
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input COM${PAGER_COM} Baud Rate:(4800|9600|38400|115200)"
					read PAGER_BAUD
					case $PAGER_BAUD in
						4800 | 9600	| 38400	| 115200 )
							echo "Set COM${PAGER_COM} Baud Rate at \"${PAGER_BAUD}\" ok? (y/n)"
							read agreement_1
							case $agreement_1 in
								y |	yes	)
									MORE='More '
									PAGER_COUNT=`expr $PAGER_COUNT + 1`
									echo "PAGER${PAGER_COUNT}=COM${PAGER_COM},${PAGER_BAUD}" >>	$INSTALLDIR/cfg/agent.ini
									echo "Add \"PAGER${PAGER_COUNT}=COM${PAGER_COM},${PAGER_BAUD}\""
									finish_1=1;;
								n |	no )
									;;
							esac;;
						* )
							;;
					esac
				done;;
		
			n |	no )
				finish=1;;
		esac
	done

	echo "PAGERCOUNT=${PAGER_COUNT}" >>	$INSTALLDIR/cfg/agent.ini
	
	finish=
	MORE=
	while [	x$finish = x -a	$PAGER_COUNT -ne 0 ]; do
		echo " "
		echo "Would You Like to Add ${MORE}Pager Receivers? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Receiver's Pager Number:"
					read PAGER_NUM
					echo "Pager Number = \"${PAGER_NUM}\" ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							;;
					esac
				done

				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Modem Interfaces: (1-${PAGER_COUNT})"
					read PAGER_IFNUM
					if [ x$PAGER_IFNUM = x ]; then
						continue
					fi
					case $PAGER_IFNUM in
						1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 )
							if [ $PAGER_IFNUM -gt $PAGER_COUNT ]; then
								continue
							fi;;
						* )
							continue;;
					esac
					echo "Modem Interface = PAGER${PAGER_IFNUM} ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							;;
					esac
				done
				
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Modem Interface Setup Code = $PAGER_SETUP ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							MORE='More '
							PAGERADDR_COUNT=`expr $PAGERADDR_COUNT + 1`
							echo "ADDR${PAGERADDR_COUNT}=${PAGER_NUM},PAGER${PAGER_IFNUM},${PAGER_SETUP}" >> $INSTALLDIR/cfg/agent.ini
							finish_1=1;;
						n |	no )
							echo "Please Input Modem Interfaces Setup Code:"
							read PAGER_SETUP;;
					esac
				done;;
			n |	no )
				finish=1;;
		esac

	done

	echo "COUNT=${PAGERADDR_COUNT}"	>> $INSTALLDIR/cfg/agent.ini

}

InputNPCFax() {
	echo "[FAX]" >>	$INSTALLDIR/cfg/agent.ini
	finish=
	MORE=
	while [	x$finish = x ];	do
		echo " "
		echo "Would You Like to Add ${MORE}Modem Interfaces For Fax? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Modem COM Port:(1-9)"
					read FAX_COM
					case $FAX_COM in
						1 |	2 |	3 |	4 |	5 |	6 |	7 |	8 |	9 )
							finish_1=1;;
						* )
							;;
					esac
				done
		
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input COM${FAX_COM} Baud Rate:(4800|9600|38400|115200)"
					read FAX_BAUD
					case $FAX_BAUD in
						4800 | 9600	| 38400	| 115200 )
							echo "Set COM${FAX_COM} Baud Rate at \"${FAX_BAUD}\" ok? (y/n)"
							read agreement_1
							case $agreement_1 in
								y |	yes	)
									MORE='More '
									FAX_COUNT=`expr	$FAX_COUNT + 1`
									echo "FAX${FAX_COUNT}=COM${FAX_COM},${FAX_BAUD}" >>	$INSTALLDIR/cfg/agent.ini
									echo "Add \"FAX${FAX_COUNT}=COM${FAX_COM},${FAX_BAUD}\""
									finish_1=1;;
								n |	no )
									;;
							esac;;
						* )
							;;
					esac
				done;;
		
			n |	no )
				finish=1;;
		esac
	done

	echo "FAXCOUNT=${FAX_COUNT}" >>	$INSTALLDIR/cfg/agent.ini
	
	finish=
	MORE=
	while [	x$finish = x -a	$FAX_COUNT -ne 0 ];	do
		echo " "
		echo "Would You Like to Add ${MORE}Fax Receivers? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Receiver's Fax Number:"
					read FAX_NUM
					echo "Fax Number = \"${FAX_NUM}\" ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							;;
					esac
				done

				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Please Input Modem Interfaces: (1-${FAX_COUNT})"
					read FAX_IFNUM
					if [ x$FAX_IFNUM = x ]; then
						continue
					fi
					case $FAX_IFNUM in
						1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 )
							if [ $FAX_IFNUM -gt $FAX_COUNT ]; then
								continue
							fi;;
						* )
							continue;;
					esac
					echo "Modem Interface = FAX${FAX_IFNUM} ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							finish_1=1;;
						n |	no )
							;;
					esac
				done
				
				finish_1=
				while [	x$finish_1 = x ]; do
					echo "Modem Interface Setup Code = $FAX_SETUP ok? (y/n)"
					read agreement_1
					case $agreement_1 in
						y |	yes	)
							MORE='More '
							FAXADDR_COUNT=`expr	$FAXADDR_COUNT + 1`
							echo "ADDR${FAXADDR_COUNT}=${FAX_NUM},RAID,FAX${FAX_IFNUM},${FAX_SETUP}" >>	$INSTALLDIR/cfg/agent.ini
							finish_1=1;;
						n |	no )
							echo "Please Input Modem Interfaces Setup Code:"
							read FAX_SETUP;;
					esac
				done;;
			n |	no )
				finish=1;;
		esac
	done
	
	echo "COUNT=${FAXADDR_COUNT}" >> $INSTALLDIR/cfg/agent.ini
	
}

InputNPCSnmptrap() {
	echo "[SNMP_TRAP]" >> $INSTALLDIR/cfg/agent.ini
	finishAll=
	while [	x$finishAll = x ];	do
		echo " "
		echo "Would You Like to Config SNMP_TRAP Function? (y/n)"
		read agreement
		case $agreement	in
			y |	yes	)
				finish=
				echo " "
				while [	x$finish = x ];	do
					echo "The Default SNMP_TRAP Setting Is [$SNMPSTAT]. Is That ok? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							case $SNMPSTAT in
								ENABLE )
									echo "ENABLED=1" >>	$INSTALLDIR/cfg/agent.ini;;
								DISABLE	)
									echo "ENABLED=0" >>	$INSTALLDIR/cfg/agent.ini
									return;;
							esac
							finish=1;;
						n |	no )
							finish_1=
							while [	x$finish_1 = x ]; do
								echo "Please Input SNMP_TRAP Status: (0:DISABLE, 1:ENABLE)"
								read SNMPSTAT
								case $SNMPSTAT in
									0 )
										SNMPSTAT='DISABLE'
										finish_1=1;;
									1 )
										SNMPSTAT='ENABLE'
										finish_1=1;;
									* )
										;;
								esac
							done;;
					esac
				done
	
				MORE=
				finish=
				while [	x$finish = x ];	do
					echo " "
					echo "Would You Like to Add ${MORE}SNMP_TRAP Recever? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							echo "Please Input SNMP_TRAP Recever's IP Address:"
							read SNMPADDR
							echo "Add SNMP_TRAP Recever${SNMP_COUNT} \"$SNMPADDR\" ok? (y/n)"
							read agreement1
							case $agreement1 in
								y |	yes	)
									echo "RECEIVER${SNMP_COUNT}=${SNMPADDR}" >>	$INSTALLDIR/cfg/agent.ini
									SNMP_COUNT=`expr $SNMP_COUNT + 1`
									MORE='More ';;
								n |	no )
									;;
							esac;;
						n |	no )
							finish=1;;
					esac
				done
	
				echo " "
				echo "SNMP TRAP SEVERITY LEVEL: "
				echo "    1.Notification: means TRAP all. "
				echo "    2.Warning: means TRAP Warning and Alert. "
				echo "    3.Alert: means only TRAP Alert. "
				finish=
				while [	x$finish = x ];	do
					case $SERVERITY	in
						1 )
							SERVERITY_TEXT='Notification';;
						2 )
							SERVERITY_TEXT='Warning';;
						3 )
							SERVERITY_TEXT='Alert';;
					esac
					echo "Set Lowest SNMP TRAP SEVERITY=${SERVERITY_TEXT} ok? (y/n)"
					read agreement
					case $agreement	in
						y |	yes	)
							echo "SEVERITY=${SERVERITY}" >>	$INSTALLDIR/cfg/agent.ini
							finish=1;;
						n |	no )
							finish_1=
							while [	x$finish_1 = x ]; do
								echo "Please Input SNMP_TRAP SERVERITY:(1-3)"
								echo "( 1:All 2:Warning & Alert 3:Alert only )"
								read SERVERITY
								case $SERVERITY	in
									1 |	2 |	3 )
										finish_1=1;;
									* )
										;;
								esac
							done;;
					esac
				done
				finishAll=1;;
			n |	no	)
				finishAll=1;;
		esac
	done

}

PrepareEnv() {
	if [ "$GUI_INST" = "1" ]; then
		unzip ${COMDIR}/gui.zip	-d ${INSTALLDIR}
		cp -r ${INSTALLDIR}/java/* ${INSTALLDIR}/bin
		rm -rf ${INSTALLDIR}/java
	fi
	
	if [ "$PRIMARY_INST" = "1" -o "SECONDARY_INST" = "1" ];	then
		if [ `/usr/bin/isainfo -b` = 64	]; then
			OSNAME='sol.spk.64'
		else
			OSNAME='sol.spk.32'
		fi		
		unzip ${COMDIR}/agents.zip ${OSNAME}/* -d ${INSTALLDIR}
		cp ${INSTALLDIR}/${OSNAME}/* ${INSTALLDIR}/bin
		rm -rf ${INSTALLDIR}/${OSNAME}
		chmod +x ${INSTALLDIR}/bin/primary
		chmod +x ${INSTALLDIR}/bin/secondary
		chmod +x ${INSTALLDIR}/bin/rcshell
	fi
	
	if [ "$NPC_INST" = "1" ]; then
		OSNAME='sol.spk'
		unzip ${COMDIR}/npc.zip	${OSNAME}/*	-d ${INSTALLDIR}
		cp ${INSTALLDIR}/${OSNAME}/* ${INSTALLDIR}/bin
		rm -rf ${INSTALLDIR}/${OSNAME}
		chmod +x ${INSTALLDIR}/bin/npc
		chmod +x ${INSTALLDIR}/bin/book
		chmod +x ${INSTALLDIR}/bin/graphic
	fi
	
	#1.	update .dtprofile
	if [ ! -r ${HOME}/.dtprofile.ori ];	then
		cp -f ${HOME}/.dtprofile ${HOME}/.dtprofile.ori
	else
		cp -f ${HOME}/.dtprofile.ori ${HOME}/.dtprofile
	fi
	
	#2.	create /etc/.iftraidagent
	if [ "$PRIMARY_INST" = "1" -o "SECONDARY_INST" = "1" ];	then
		echo " " > /etc/.iftraidagent
		if [ "$SECONDARY_INST" = "1" ];	then
			echo "${INSTALLDIR}/bin/secondary" >> /etc/.iftraidagent
		fi
		if [ "$PRIMARY_INST" = "1" ]; then
			echo "${INSTALLDIR}/bin/primary" >>	/etc/.iftraidagent
		fi
		chmod +x /etc/.iftraidagent
	fi			
	
	#3.	update /etc/inittab
	if [ -r	/etc/.iftraidagent ]; then
		if [ ! -r /etc/inittab.ori ]; then
			cp -f /etc/inittab /etc/inittab.ori
		else
			cp -f /etc/inittab.ori /etc/inittab
		fi
		echo "ift::boot:/etc/.iftraidagent"	>> /etc/inittab
	fi
	
	#4.	create uninstal.sh
	echo "INSTALLDIR=${INSTALLDIR}"	> ${INSTALLDIR}/bin/uninstal.sh
	echo "`cat ${OSDIR}/uninstal.sh`" >> ${INSTALLDIR}/bin/uninstal.sh
	chmod +x ${INSTALLDIR}/bin/uninstal.sh

	if [ "$GUI_INST" = "1" ]; then
	#5.	create grm.sh
		echo "cd ${INSTALLDIR}/bin"	> /usr/bin/grm.sh
		echo "/usr/Solaris_JRE_1.2.2_05/bin/java -jar grm.jar >	/dev/null 2>&1"	>> /usr/bin/grm.sh
		chmod +x /usr/bin/grm.sh
	
	#6.	create grem.sh
		echo "cd ${INSTALLDIR}/bin"	> /usr/bin/grem.sh
		echo "/usr/Solaris_JRE_1.2.2_05/bin/java -cp grm.jar:grem.jar grem.EvtWatch	> /dev/null	2>&1" >> /usr/bin/grem.sh
		chmod +x /usr/bin/grem.sh
	fi
	
	#7 update ${HOME}/.dtprofile
	echo "PATH=\$PATH:${INSTALLDIR}/bin; export	PATH" >	/usr/.ift.ini
	. /usr/.ift.ini
	#cat /usr/.ift.ini >> ${HOME}/.dtprofile
	echo "PATH=/usr/Solaris_JRE_1.2.2_05/bin:\$PATH:${INSTALLDIR}/bin; export PATH"	>> ${HOME}/.dtprofile
	
	#8 Start Agent......
	#secondary > /dev/null 2>&1
	#primary > /dev/null 2>&1
	#rm -f /usr/.ift.ini	> /dev/null	2>&1
	
	#9 Prepare .javagui.ini
	echo "Primary Agent,${INSTALLDIR}/bin/"	> ${INSTALLDIR}/.javagui.ini
	echo "Secondary	Agent,${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
	echo "RaidWatch,${INSTALLDIR}/bin/"	>> ${INSTALLDIR}/.javagui.ini
	echo "Notification Processing Center(NPC),${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
	echo "System Files,${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
	echo "System Files,${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
	echo "System Files,${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
	echo "EventMonitor,${INSTALLDIR}/bin/" >> ${INSTALLDIR}/.javagui.ini
}


# main program ----------------------------------------------------------------	
cd ..
SRCDIR=`pwd`
OSDIR=${SRCDIR}/solaris7.spc
#COMDIR=${SRCDIR}/common
cd ..
COMDIR=`pwd`/common
GUIDIR=`pwd`/solaris7.spc
cd ${SRCDIR}

#Agent parameters
INSTALLDIR='/usr/hybrid'
PRIMARYIP=
PRIMARYPORT=58632
SECONDARYIP=
SECONDARYPORT=58633
MAX_CLIENT=20
MAX_CONTROLLER=30
PREFERRED_MODE=ACTIVE
NEGOTIATION_TIME=90
EVENT_POLL_TIME=10
OSNAME=
PEER_PRIMARY=
PEER_PRIMARY_PORT=58632
PREFERRED_MODE=ACTIVE
NEGOTIATION_TIME=90

#NPC parameters
MYEMAIL=
SMTPSERVER=
EMAIL_COUNT=0
EMAILSUB='Raid Event'
EMAILCONTENT='119'
BROADCAST_COUNT=0
PAGERADDR_COUNT=0
PAGER_COUNT=0
PAGER_SETUP='V1B1E0F0L1M1Q0TV1X1Y0&C1&D2&G0S7=20'
FAXADDR_COUNT=0
FAX_COUNT=0
FAX_SETUP='&F1X0M0'
SNMP_COUNT=1
SNMPSTAT='ENABLE'
SERVERITY=1

#Flags
PRIMARY_INST=0
SECONDARY_INST=0
NPC_INST=0
GUI_INST=0

# Save original	path setting
if [ ! -r /usr/.path.ori ];	then
   echo	"`echo $PATH`" > /usr/.path.ori
fi

# Set path for JRE
#PATH=/usr/Solaris_JRE_1.2.2_05/bin:$PATH; export PATH

more <<	"EOF"

*********************************************************************
        Text-mode RAID Agents Installation Procedure v1.11j
                        Solaris 7 SPARC
*********************************************************************

=====================================================================
SECTION	I: Pre-Installation	(Patches Installation)
=====================================================================

*NOTE: Before you can install JRE v1.2 (Java Runtime Enviroment) successfully, you should have installed patches for Solaris 7 .

!!! PLEASE DOWNLOAD THE PATCHES REQUIRED FROM SUN'S WEB SITE, AND INSTALL IT !!!

EOF

echo "If you have downloaded patches, and put them on proper directory, install program will install patches for you."
echo
echo "Would you like to auto-install the patches now ?"
echo
echo "*NOTE: 1.You need to download patches tar file in advance."
echo "       2.Then, put the tar file on \"/usr/patches/\" ."
echo
agreed=
while [	x$agreed = x ];	do
	echo "Please type yes or no."
	read reply 
	case $reply	in
	   y* |	Y*)
		  mkdir	-p /usr/patches	
		  echo 
		  echo "You are going to install patches now."
		  echo "Please check to see if the patches tar file is on \"/usr/patches/\" ."
		  echo
		  echo "Would you like to continue ?"
		  agreed=
		  while	[ x$agreed = x ]; do
			 echo "Please type yes or no."
			 read reply
			 case $reply in
				y* | Y*)
				   echo
				   echo	"Start to install patches ..."
				   echo
				   cd /usr/patches
				   mkdir -p	tarfile
				   for file	in *.tar  
				   do
					  tar -xvf $file
				   done	  
				   if [	! -d 5.7 ];	then
					  echo
					  echo "patches tar file doesn't exist !"
					  echo
					  echo "Patches installation failed !"
					  exit 1
				   fi	
				   cd 5.7
				   for file	in *.Z
				   do
					  uncompress $file
				   done
				   for file	in *.tar
				   do 
					  tar -xvf $file
					  mv $file ../tarfile
				   done
				   for file	in *
				   do
					  patchadd $file
				   done	 
				   rm -fr /usr/patches/tarfile > /dev/null 2>&1
				   rm -fr /usr/patches/5.7 > /dev/null 2>&1
				   echo			
				   echo	"Patches installation finished."				   
				   echo
				   agreed=1;;
				n* | N*)
				   exit	0;;
			 esac
		  done							
		  agreed=1;;
	   n* |	N*)
		  echo
		  echo "Please make sure you have installed patches for Solaris 7 ."
		  echo "Then, you may step into JRE v1.2.2 installation procedure."
		  echo
		  echo "Would you like to continue ?"
		  agreed=
		  while	[ x$agreed = x ]; do
			 echo "Please type yes or no."
			 read reply
			 case $reply in
				y* | Y*)
				   agreed=1;;
				n* | N*)
				   exit	0;;
			 esac
		  done							
		  agreed=1;;
	esac
done

more <<	"EOF"



=====================================================================
SECTION II: JRE v1.2 Installation
=====================================================================
*NOTE: Before you can run Java-based program successfully, you should have
       installed JRE(Java Runtime Enviroment). 



EOF

echo "Would you like to install JRE v1.2 now ?"
agreed=
while [	x$agreed = x ];	do
	echo "Please type yes or no."
	read reply 
	case $reply	in
	   y* |	Y*)
		  cd /usr
#		   ${OSDIR}/jre2.bin;
		  ${GUIDIR}/jre2.bin
		  #	Add	path for JRE 
		  PATH=/usr/Solaris_JRE_1.2.2_05/bin:`cat /usr/.path.ori`; export PATH
		  echo "install	JRE" > /usr/.jre
		  agreed=1;;
	   n* |	N*)
		  echo "Install JRE v1.2 Canceled !"
		  agreed=1;;
	esac
done

more <<	"EOF"



=====================================================================
SECTION III: Java Plug-in v1.2 Installation
=====================================================================
*NOTE: If you would like to run Java-based GUI RAID Manager through web
       browser(e.g. Netscape Navigator), you should have install Java Plug-
       in. 



EOF

echo "Would you like to install Java Plug-in v1.2 now ?"
agreed=
while [	x$agreed = x ];	do
	echo "Please type yes or no."
	read reply 
	case $reply	in
	   y* |	Y*)
		  cd /usr
#		   tar -xvf	${OSDIR}/j2pi.tar
		  tar -xvf ${GUIDIR}/j2pi.tar
		  pkgadd -d	. SUNWj2pi
		  rm -f	SUNWj2pi > /dev/null 2>&1
		  agreed=1;;
	   n* |	N*)
		  echo "Install Java Plug-in v1.2 Canceled !" 
		  agreed=1;;
	esac
done

# Install .java.policy & .keystore
(cp	-f ${COMDIR}/keystore.jav ${HOME}/.keystore) > /dev/null 2>&1
(cp	-f ${COMDIR}/policy.jav	${HOME}/.java.policy) >	/dev/null 2>&1

more <<	"EOF"



=====================================================================
SECTION IV: RAID Agents Installation
=====================================================================



EOF
 
agreed=
while [	x$agreed = x ];	do
	echo "Would you like to install RAID Agent now? (y/n)"
	read reply 
	case $reply	in
		yes	| y)
			InputInstallPath
			if [ $?	-ne	0 ]; then
				cd ${OSDIR}
				return 0
			fi
			agreed1=
			echo " "
			while [	x$agreed1 =	x ]; do
				echo "Would you like to install Primary Agent? (y/n)"
				read answer
				case $answer in
					y |	yes	)
						PRIMARY_INST=1
						InputPrimaryAgentProperty
						agreed1=1;;
					n |	no )
						agreed1=1;;
				esac
			done
			agreed1=
			echo " "
			while [	x$agreed1 =	x ]; do
				echo "Would you like to install Secondary Agent? (y/n)"
				read answer
				case $answer in
					y |	yes	)
						SECONDARY_INST=1
						InputSecondaryAgentProperty
						agreed1=1;;
					n |	no )
						agreed1=1;;
				esac
			done
			agreed1=
			echo " "
			while [	x$agreed1 =	x ]; do
				echo "Would you like to install Notification Processing Center (NPC)? (y/n)"
				read answer
				case $answer in
					y |	yes	)
						NPC_INST=1
						InputNPCProperty
						agreed1=1;;
					n |	no )
						agreed1=1;;
				esac
			done	
			agreed1=
			echo " "
			while [	x$agreed1 =	x ]; do
				echo "Would you like to install Java-based GUI Raid Manager? (y/n)"
				read answer
				case $answer in
					y |	yes	)
						GUI_INST=1
						# Install .java.policy & .keystore
						(cp	-f ${COMDIR}/keystore.jav ${HOME}/.keystore) > /dev/null 2>&1
						(cp	-f ${COMDIR}/policy.jav	${HOME}/.java.policy) >	/dev/null 2>&1
						agreed1=1;;
					n |	no )
						agreed1=1;;
				esac
			done	
			PrepareEnv
			DASC_TEST=`modinfo|grep	dasc`
			DASC_INST="[$DASC_TEST]"
			if [ "$SECONDARY_INST" = "1" ];	then
				if [ "$DASC_INST" != "[]" ]; then
					secondary >	/dev/null 2>&1
				else
					echo " "
					echo " Note : In-Band SCSI Driver Not Install yet!"
					echo "        Please Start Secondary Agent After In-Band SCSI Driver Installed."
					echo " "
				fi
			fi
			if [ "$PRIMARY_INST" = "1" ]; then
				primary	> /dev/null	2>&1
			fi
			echo "Install RAID Agent Finished!"
			agreed=1;;
		no | n)
			echo "Install RAID Agent Canceled!";
			if [ ! -r ${HOME}/.dtprofile.ori ];	then
				cp -f ${HOME}/.dtprofile ${HOME}/.dtprofile.ori
			else
				cp -f ${HOME}/.dtprofile.ori ${HOME}/.dtprofile
			fi
			if [ -r	/usr/.jre ]; then
				JRE_INST=`cat /.dtprofile |	grep PATH |	grep /usr/Solaris_JRE_1.2.2_05/bin`
				if [ -z	$JRE_INST ]; then
					echo "PATH=/usr/Solaris_JRE_1.2.2_05/bin:\$PATH;export PATH">>/.dtprofile
				fi
			fi
			agreed=1;;
	esac
done

more <<	"EOF"



=====================================================================
SECTION V: In-band SCSI Driver Installation
=====================================================================

*NOTE: You need to install inband driver before you can manage stand-alone RAID controller.

EOF
 
echo "Would you like to install In-band SCSI Driver now ?"
agreed=
while [	x$agreed = x ];	do
	echo "Please type yes or no."
	read reply 
	case $reply	in
	   y* |	Y*)
		  if [ `/usr/bin/isainfo -b` = 64 ]; then
			 cp	-f ${GUIDIR}/dasc64/dasc.ori /usr/kernel/drv/sparcv9/dasc >	/dev/null 2>&1
			 cp	-f ${GUIDIR}/dasc64/dasc.con /usr/kernel/drv/dasc.conf > /dev/null 2>&1
			 ${GUIDIR}/dasc64/dascinst.sh
		  else
			 cp	-f ${GUIDIR}/dasc32/dasc.ori /usr/kernel/drv/dasc >	/dev/null 2>&1
			 cp	-f ${GUIDIR}/dasc32/dasc.con /usr/kernel/drv/dasc.conf > /dev/null 2>&1
			 ${GUIDIR}/dasc32/dascinst.sh
		  fi	  
		  echo
		  echo "Install In-band SCSI Driver Finished !";
		  echo 
#		   echo	"!!! You need to restart system	to get In-band SCSI	Driver started !!!"
		  agreed=1;;
	   n* |	N*)
		  echo "Install In-band SCSI Driver canceled !";
		  agreed=1;;
	esac
done
